subroutine evolve_k5(k11m1,k12m1,k13m1,k21m1,k22m1,k23m1,k31m1,k32m1,k33m1, &
                    t11,t12,t13,t21,t22,t23,t31,t32,t33,dt)

use types
use hpfprocessors

real(SP), dimension(:,:,:), intent(INOUT):: k11m1,k12m1,k13m1,k21m1,k22m1, &
                                            k23m1,k31m1,k32m1,k33m1
real(SP), dimension(:,:,:), intent(INOUT):: t11,t12,t13,t21,t22,t23,t31,t32,t33
real(SP) dt

!HPF$ DISTRIBUTE *(*,BLOCK,BLOCK) ONTO *PROC :: k11m1
!HPF$ ALIGN WITH *k11m1 :: k12m1,k13m1,k21m1,k22m1,k23m1,k31m1,k32m1,k33m1
!HPF$ ALIGN WITH *k11m1 :: t11,t12,t13,t21,t22,t23,t31,t32,t33

!     Evolve one timestep via leapfrog method ( i.e. time-centered)

      t11 = 2.0d0*dt*t11 + k11m1 
      t12 = 2.0d0*dt*t12 + k12m1 
      t13 = 2.0d0*dt*t13 + k13m1 
      t21 = 2.0d0*dt*t21 + k21m1 
      t22 = 2.0d0*dt*t22 + k22m1 
      t23 = 2.0d0*dt*t23 + k23m1 
      t31 = 2.0d0*dt*t31 + k31m1 
      t32 = 2.0d0*dt*t32 + k32m1 
      t33 = 2.0d0*dt*t33 + k33m1 

      k11m1 = t11
      k12m1 = t12
      k13m1 = t13
      k21m1 = t21
      k22m1 = t22
      k23m1 = t23
      k31m1 = t31
      k32m1 = t32
      k33m1 = t33

      return
      end




